#include "../include/apsrstack-general.h"

/* TODO: move later in scheduler.c */
void queue_check (int sig) {
	if(sig == SIGALRM) {
		/* Only dummy for now */
		apsr_output("Scheduler(%s): checking queue\n",
				apsr_get_time_formatted());
        }

	if(signal(SIGALRM, (apsrstack_queue_check_callback)queue_check) == SIG_ERR) {
		#ifdef APSRSTACK_DEBUG
		apsr_stream_output(stderr, "Error: Signal error while SIGALRM catching.\n");
		#endif
        }
}

/* Main function */
int main (int argc, char **argv, char **env) {
  struct itimerval queue_timer;
  unsigned short c = 0;

  apsrstack_src_mac[0] = APSRSTACK_MAC_1;
  apsrstack_src_mac[1] = APSRSTACK_MAC_2;
  apsrstack_src_mac[2] = APSRSTACK_MAC_3;
  apsrstack_src_mac[3] = APSRSTACK_MAC_4;
  apsrstack_src_mac[4] = APSRSTACK_MAC_5;
  apsrstack_src_mac[5] = APSRSTACK_MAC_6;
  
  apsrstack_src_ip[0] = APSRSTACK_IP_1;
  apsrstack_src_ip[1] = APSRSTACK_IP_2;
  apsrstack_src_ip[2] = APSRSTACK_IP_3;
  apsrstack_src_ip[3] = APSRSTACK_IP_4;

  /* Set all of the TCP queue to connection state CLOSED */
  for(c = 0; c < APSRSTACK_TCP_MAX_CONNECTIONS; c++) 
	  tcp_queue[c].state = APSRSTACK_TCP_STATE_CLOSED;

  for(c = 0; c < APSRSTACK_TCP_MAX_PORTS; c++) 
	  tcp_listen_ports[c] = 0;  

  /* Initialize time for queue scheduler */
  queue_timer.it_interval.tv_sec  = APSRSTACK_TIMER_SEC;
  queue_timer.it_interval.tv_usec = 0;
  queue_timer.it_value.tv_sec     = APSRSTACK_TIMER_SEC;
  queue_timer.it_value.tv_usec    = 0;
  if(signal(SIGALRM, (apsrstack_queue_check_callback)queue_check) == SIG_ERR) {
	  #ifdef APSRSTACK_DEBUG
	  apsr_stream_output(stderr, "Error: Signal error while SIGALRM catching.\n");
          #endif
  }
  setitimer(ITIMER_REAL, &queue_timer, 0);
  
  /* Install some signal handlers */
  if(apsr_install_sig((apsr_exit_callback)clean_exit) == RET_FAILURE) 
	  ERROR("apsr_install_sig failed!");

  service_time_init();
  
  parseoptions(argc, argv);

  service_time_close();
  
  clean_exit(EXIT_SUCCESS); 	
  exit(EXIT_SUCCESS);
}

